# We're dropping things into the debug location; don't want a -debuginfo
# package:
%global debug_package %{nil}
# (I tried using _enable_debug_packages but that didn't work for some reason)

Name:           gdb-heap
Version:        0.2
Release:        1%{?dist}
Summary:        Extensions to gdb for debugging dynamic memory allocation

# We build this arch-specific so that we can follow /lib vs /lib64 differences
# in the location of the underlying glibc library

Group:          Development/Libraries
License:        LGPLv2+ and PSF

# Made from upstream commit a35f2934f7b7afc2f305db2b6360a269d3e39901
# git clone git://git.fedorahosted.org/gdb-heap.git
# mv gdb-heap gdb-heap-0.2
# tar cfvj gdb-heap-0.2.tar.bz2 gdb-heap-0.2
# scp gdb-heap-0.2.tar.bz2 dmalcolm@fedorahosted.org:gdb-heap

URL:            https://fedorahosted.org/gdb-heap/
Source0:        https://fedorahosted.org/released/gdb-heap/gdb-heap-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  python

%global glibc_version 2.11.2
%global glibc_soversion %{glibc_version}
%global glibc_dso_name  ld-%{glibc_soversion}.so
%global glibc_debug_dir %{_prefix}/lib/debug/%{_lib}
%global glibc_debug_dso_path %{glibc_debug_dir}/%{glibc_dso_name}.debug
%global script_install_path  %{glibc_debug_dso_path}-gdb.py

%global module_install_path %{_datadir}/gdb-heap

# This is autoloaded by gdb if the relevant glibc library is in memory.
# It is only usable if that glibc library's debuginfo is available.
# To do this, it must be at the correct location on the filesystem 
# For this to work, we need a matching glibc version:
Requires: glibc%{_isa} = %{glibc_version}

# Strictly speaking, we really require:
# Requires: glibc-debuginfo%{_isa} = %{glibc_version}
# but it's debatable if that's a legitimate requirement

%description
gdb-heap adds a "heap" command to the gdb debugger, for use in debugging
dynamic memory allocation problems in user space.

%prep
%setup -q

%build
# empty

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}/%{glibc_debug_dir}

mkdir -p %{buildroot}/%{module_install_path}/heap
cp -a heap/*.py %{buildroot}/%{module_install_path}/heap

# Build the auto-loaded entrypoint script, adding module_install_path
# to sys.path:
echo \
  "import sys; sys.path.append('%{module_install_path}')" \
  > %{buildroot}/%{script_install_path}

cat gdbheap.py \
  >> %{buildroot}/%{script_install_path}


%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc LICENSE.txt
%{script_install_path}*
%{module_install_path}


%changelog
* Thu Jul 29 2010 David Malcolm <dmalcolm@redhat.com> - 0.2-1
- 0.2
- install private modules to _datadir rather than _libdir

* Tue Jul 27 2010 David Malcolm <dmalcolm@redhat.com> - 0.1-2
- fix License tag
- require specific glibc package version, rather than a specific file within
glibc-debuginfo
- standardize on buildroot rpm macro rather than RPM_BUILD_ROOT env var

* Mon Jul 26 2010 David Malcolm <dmalcolm@redhat.com> - 0.1-1
- initial packaging
